package cn.ysk.cashier.utils;

import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;

/**
 * Created by SEELE on 2018/4/19.
 */
public class DateUtils {

    private final static SimpleDateFormat sdfYear = new SimpleDateFormat("yyyy");
    private final static SimpleDateFormat sdfDay = new SimpleDateFormat("yyyy-MM-dd");
    private final static SimpleDateFormat sdfDays = new SimpleDateFormat("yyyyMMdd");
    private final static SimpleDateFormat sdfTime = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
    private final static SimpleDateFormat sdfTimeSS = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss.SSS");
    private final static SimpleDateFormat sdfTimes = new SimpleDateFormat("yyyyMMddHHmmss");


    private final static SimpleDateFormat sdfTimesSs = new SimpleDateFormat("yyyyMMddHHmmssSSS");



    private final static SimpleDateFormat sdfday = new SimpleDateFormat("MM-dd HH:mm");


    public static Date getNewDate(Date date, Integer type, Integer interval) throws ParseException {
        Calendar c = Calendar.getInstance();
        c.setTime(date);
        switch (type) {
            case 1:
                c.set(Calendar.YEAR, (c.get(Calendar.YEAR) + interval));
                break;
            case 2:
                c.set(Calendar.MONTH, (c.get(Calendar.MONTH) + interval));
                break;
            case 3:
                c.set(Calendar.DATE, (c.get(Calendar.DATE) + interval));
                break;
            case 4:
                c.set(Calendar.HOUR, (c.get(Calendar.HOUR) + interval));
                break;
            case 5:
                c.set(Calendar.MINUTE, (c.get(Calendar.MINUTE) + interval));
                break;
            default:
                c.set(Calendar.SECOND, (c.get(Calendar.SECOND) + interval));
                break;
        }
        Date newDate = c.getTime();
        return sdfTime.parse(sdfTime.format(newDate));
    }


    /**
     * 获取YYYY格式
     * @return
     */
    public static String getSdfTimes() {
        return sdfTimes.format(new Date());
    }


    public static String getSsdfTimes() {
        return sdfTimesSs.format(new Date());
    }

    public static  String getNextSdfTimes(Date date){
        return sdfTimes.format(date);
    }



    public static  String getTimes(Date date){
        return sdfday.format(date);
    }


    /**
     * 获取YYYY格式
     * @return
     */
    public static String getYear() {
        return sdfYear.format(new Date());
    }

    /**
     * 获取YYYY-MM-DD格式
     * @return
     */
    public static String getDay() {
        return  sdfDay.format(new Date());
    }

    /**
     * 获取YYYYMMDD格式
     * @return
     */
    public static String getDays(){
        return sdfDays.format(new Date());
    }

    /**
     * 获取YYYY-MM-DD HH:mm:ss格式
     * @return
     */
    public static String getTime(Date date) {
        return sdfTime.format(date);
    }

    /**
     * @Title: compareDate
     * @Description: TODO(日期比较，如果s>=e 返回true 否则返回false)
     * @param s
     * @param e
     * @return boolean
     * @throws
     * @author fh
     */
    public static boolean compareDate(String s, String e) {
        if(fomatDate(s)==null||fomatDate(e)==null){
            return false;
        }
        return fomatDate(s).getTime() >=fomatDate(e).getTime();
    }

    /**
     * 格式化日期
     * @return
     */
    public static Date fomatDate(String date) {
        DateFormat fmt = new SimpleDateFormat("yyyy-MM-dd");
        try {
            return fmt.parse(date);
        } catch (ParseException e) {
            e.printStackTrace();
            return null;
        }
    }

    /**
     * 校验日期是否合法
     * @return
     */
    public static boolean isValidDate(String s) {
        DateFormat fmt = new SimpleDateFormat("yyyy-MM-dd");
        try {
            fmt.parse(s);
            return true;
        } catch (Exception e) {
            // 如果throw java.text.ParseException或者NullPointerException，就说明格式不对
            return false;
        }
    }

    /**
     * @param startTime
     * @param endTime
     * @return
     */
    public static int getDiffYear(String startTime,String endTime) {
        DateFormat fmt = new SimpleDateFormat("yyyy-MM-dd");
        try {
            //long aa=0;
            int years=(int) (((fmt.parse(endTime).getTime()-fmt.parse(startTime).getTime())/ (1000 * 60 * 60 * 24))/365);
            return years;
        } catch (Exception e) {
            // 如果throw java.text.ParseException或者NullPointerException，就说明格式不对
            return 0;
        }
    }

    /**
     * <li>功能描述：时间相减得到天数
     * @param beginDateStr
     * @param endDateStr
     * @return
     * long
     * @author Administrator
     */
    public static long getDaySub(String beginDateStr,String endDateStr){
        long day=0;
        SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd");
        Date beginDate = null;
        Date endDate = null;

        try {
            beginDate = format.parse(beginDateStr);
            endDate= format.parse(endDateStr);
        } catch (ParseException e) {
            e.printStackTrace();
        }
        day=(endDate.getTime()-beginDate.getTime())/(24*60*60*1000);
        //System.out.println("相隔的天数="+day);

        return day;
    }

    /**
     * 得到n天之后的日期
     * @param days
     * @return
     */
    public static String getAfterDayDate(String days) {
        int daysInt = Integer.parseInt(days);

        Calendar canlendar = Calendar.getInstance(); // java.util包
        canlendar.add(Calendar.DATE, daysInt); // 日期减 如果不够减会将月变动
        Date date = canlendar.getTime();

        SimpleDateFormat sdfd = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        String dateStr = sdfd.format(date);

        return dateStr;
    }
    /**
     * 得到n天之后的日期
     * @param days
     * @return
     */
    public static String getAfterDate(Date openDate,String days) {
        int daysInt = Integer.parseInt(days);

        Calendar canlendar = Calendar.getInstance(); // java.util包
        canlendar.setTime(openDate);
        canlendar.add(Calendar.DATE, daysInt); // 日期减 如果不够减会将月变动
        Date date = canlendar.getTime();
        SimpleDateFormat sdfd = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        String dateStr = sdfd.format(date);
        return dateStr;
    }
    public static String getAfterDate1(Date openDate,String year) {
        int daysInt = Integer.parseInt(year);

        Calendar canlendar = Calendar.getInstance(); // java.util包
        canlendar.setTime(openDate);
        canlendar.add(Calendar.YEAR, daysInt); // 日期减 如果不够减会将月变动
        Date date = canlendar.getTime();
        SimpleDateFormat sdfd = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        String dateStr = sdfd.format(date);
        return dateStr;
    }
    public static Date getAfterDateStr(Date openDate,String days) {
        int daysInt = Integer.parseInt(days);

        Calendar canlendar = Calendar.getInstance(); // java.util包
        canlendar.setTime(openDate);
        canlendar.add(Calendar.DATE, daysInt); // 日期减 如果不够减会将月变动
        Date date = canlendar.getTime();
        return date;
    }

    /**
     * 得到n天之后是周几
     * @param days
     * @return
     */
    public static String getAfterDayWeek(String days) {
        int daysInt = Integer.parseInt(days);
        Calendar canlendar = Calendar.getInstance(); // java.util包
        canlendar.add(Calendar.DATE, daysInt); // 日期减 如果不够减会将月变动
        Date date = canlendar.getTime();
        SimpleDateFormat sdf = new SimpleDateFormat("E");
        String dateStr = sdf.format(date);
        return dateStr;
    }

    public static void main(String[] args) {
        System.out.println(getTimes(new Date()));
    }

    /**
     * 格式化日期为时分秒
     * @param date
     * @return
     */
    public static Date fomatDateTime(String date) {
        DateFormat fmt = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        try {
            return fmt.parse(date);
        } catch (ParseException e) {
            e.printStackTrace();
            return null;
        }
    }



    public static Date fomatDateTime1(String date) {
        DateFormat fmt = new SimpleDateFormat("yyyyMMddHHmmss");
        try {
            return fmt.parse(date);
        } catch (ParseException e) {
            e.printStackTrace();
            return null;
        }
    }


    public static Date parse(String dateString, String dateFormat) {
        if ("".equals(dateString.trim()) || dateString == null) {
            return null;
        }
        DateFormat sdf = new SimpleDateFormat(dateFormat);
        Date date = null;
        try {
            date = sdf.parse(dateString);

        } catch (Exception e) {
            e.printStackTrace();
        }

        return date;
    }


    private final static SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMddHHmmss");
    public static Date convertDate(String date) {
        try {
            return  sdf.parse(date);
        } catch (ParseException e) {
            throw new RuntimeException(e);
        }
    }

    private final static SimpleDateFormat sdf1 = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");

    public static Date convertDateByString(String str){
        StringBuilder sb=new StringBuilder();
        sb.append(str.substring(0,4));
        sb.append("-");
        sb.append(str.substring(4,6));
        sb.append("-");
        sb.append(str.substring(6,8));
        sb.append(" ");
        sb.append(str.substring(8,10));
        sb.append(":");
        sb.append(str.substring(10,12));
        sb.append(":");
        sb.append(str.substring(12,14));

        return convertDate1(sb.toString());
    }

    public static Date convertDate1(String date) {
        try {
            return  sdf1.parse(date);
        } catch (ParseException e) {
            throw new RuntimeException(e);
        }
    }


    public static String formatDateToStr(Date date) {
        return sdfTime.format(date);
    }

}
